using Bbm.Bbmnet.Integracao.Util.Xml;
using ServiceTester.Integracao;
using System;
using System.ComponentModel;
using System.Configuration;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using intg = Bbm.Bbmnet.Integracao.Business.Entities;

namespace ServiceTester.Edital
{
    public partial class ConsultarEditalResultado : Form
    {
        public ConsultarEditalResultado()
        {
            InitializeComponent();            
        }

        private void ConsultarResultadoEdital_Load(object sender, EventArgs e)
        {
            tabPrincipal.SelectedTab = tbpParametros;
            //txtProtocoloEnvio.Text = string.Empty;
            this.grpLotes.Text = "Lotes";
        }

        private void ConsultarEditalResultadoTeste()
        {
            try
            {
                using (var client = new WCFIntegracaoClient())
                {
                    string result = client.ConsultarEditalResultado("");
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        private BindingList<intg.Lote> _lotesResultado;
        public BindingList<intg.Lote> LotesResultado
        {
            get
            {
                return _lotesResultado;
            }
            set
            {
                _lotesResultado = value;
            }
        }

        private int _indice;
        public int Indice
        {
            get
            {
                return _indice;
            }
            set
            {
                _indice = value;
            }
        }

        private void btnExecutar_Click(object sender, EventArgs e)
        {
            // Utilizando o novo componente de integracao
            #region Nova integrao
            WCFIntegracaoClient client = new WCFIntegracaoClient();

            if (!this.ConfigurarProxy(client))
                return;

            if (!Regex.IsMatch(txtProtocoloEnvio.Text, @"^\d+$"))
            {
                MessageBox.Show("Entre com um valor numrico maior que zero.");
                return;
            }

            try
            {
                string _protocolo = (string.IsNullOrEmpty(txtProtocoloEnvio.Text) ? "1511101822247745" : txtProtocoloEnvio.Text);

                bsResultado.Clear();
                string _strEdital = client.ConsultarEditalResultado(_protocolo);

                if (string.IsNullOrEmpty(_strEdital))
                {
                    tabPrincipal.SelectedTab = tbpParametros;
                    throw new ApplicationException("Nenhum resultado retornado.");
                }

                //Adicionar Resultado  Propriedade Local
                this._lotesResultado = new BindingList<intg.Lote>();
                intg.Edital editalRst = new intg.Edital();
                editalRst = Serializer.Deserialize<intg.Edital>(_strEdital);

                foreach (var item in editalRst.Lotes)
                {
                    this._lotesResultado.Add(item);
                }

                this.grpLotes.Text = string.Format("Lotes - Cdigo Edital/Aviso: {0}", editalRst.Codigo);

                //Associar Resultado ao DataSource
                bsResultado.DataSource = this._lotesResultado;

                //Exibir Tab de Resultado
                tabPrincipal.SelectedTab = tbpResultado;

                txtXmlResult.Text = _strEdital;

            }
            catch (Exception ex)
            {
                MessageBox.Show(TraceException(ex));
            }

            #endregion

            // Utilizando o antigo componente de integracao
            #region Antiga integrao
            /*
            BindingList<TOLoteResultado> _resultado;
            GerenciadorEditalClient _proxy = new GerenciadorEditalClient();

            if (!this.ConfigurarProxy(_proxy))
                return;

            if (!Regex.IsMatch(txtCodigoEdital.Text, @"^\d+$"))
            {
                MessageBox.Show("Entre com um valor numrico maior que zero.");
                return;
            }

            try
            {
                int _codigoEdital = int.Parse(txtCodigoEdital.Text);

                bsTOLoteResultado.Clear();
                _resultado = _proxy.ConsultarEditalResultado(_codigoEdital);

                if (_resultado == null || _resultado.Count == 0)
                {
                    tabPrincipal.SelectedTab = tbpParametros;
                    throw new ApplicationException("Nenhum resultado retornado.");
                }

                //Adicionar Resultado  Propriedade Local
                this._lotesResultado = _resultado;
                this.grpLotes.Text = string.Format("Lotes - Cdigo Edital/Aviso: {0}", _codigoEdital);

                //Associar Resultado ao DataSource
                bsTOLoteResultado.DataSource = this._lotesResultado;

                //Exibir Tab de Resultado
                tabPrincipal.SelectedTab = tbpResultado;
            }
            catch (Exception ex)
            {
                MessageBox.Show(TraceException(ex));
            }
            */
            #endregion
        }

        private void TOLoteResultadoDataGridView_CellMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            this.InstanciarDetalhe(e.RowIndex);
        }

        private void InstanciarDetalhe(int indice)
        {
            try
            {
                this.Indice = indice;

                DetalhesLote _frmDetalhes = new DetalhesLote();
                _frmDetalhes.Show(this);
            }
            catch (Exception ex)
            {
                MessageBox.Show(TraceException(ex));
            }
        }

        private bool ConfigurarProxy(WCFIntegracaoClient client)
        {
            int TimeOut;

            try
            {
                client.ClientCredentials.UserName.UserName = ConfigurationManager.AppSettings["Usuario"];
                client.ClientCredentials.UserName.Password = ConfigurationManager.AppSettings["Password"];

                int.TryParse(ConfigurationManager.AppSettings["TimeOut"], out TimeOut);
                if (TimeOut > 0)
                {
                    client.InnerChannel.OperationTimeout = new TimeSpan(0, TimeOut, 0);
                }
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(TraceException(ex));
                return false;
            }
        }

        private static string TraceException(Exception excecao)
        {
            StringBuilder _trace = new StringBuilder();
            _trace.AppendLine("---------------");
            _trace.AppendLine("Exceo Gerada:");
            _trace.AppendFormat("Message:({0})", excecao.Message);
            _trace.AppendFormat("Source:({0})", excecao.Source);
            //_trace.AppendFormat("StackTrace:({0})", excecao.StackTrace);
            if (excecao.InnerException != null)
            {
                _trace.AppendLine(TraceException(excecao.InnerException));
            }
            return _trace.ToString();
        }
    }
}