using Bbm.Bbmnet.Integracao.Business.Entities.Collections;
using Bbm.Bbmnet.Integracao.Util.Xml;
using ServiceTester.Integracao;
using ServiceTester.Util;
using System;
using System.Windows.Forms;

namespace ServiceTester.Produto
{
    public partial class ConsultarProduto : Form
    {
        private int PgSize = 10;
        private int CurrentPageIndex = 0;
        private int CurrentPage = 1;
        public ConsultarProduto()
        {
            InitializeComponent();
        }
        private void btnExecutar_Click(object sender, EventArgs e)
        {
            CurrentPage = 1;
            CurrentPageIndex = 0;
            BuscarProdutos();
        }
        private void BuscarProdutos()
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                using (WCFIntegracaoClient proxy = ServiceFactory.GetIntegracaoInstance())
                {
                    var result = proxy.ConsultarProdutosPaginado(txtPesquisa.Text, chkProdutosOrgao.Checked, chkProdutosBBM.Checked, "", PgSize, CurrentPageIndex);
                    var produtos = Serializer.Deserialize<ProdutoCollection>(result);

                    bsResultado.Clear();
                    bsResultado.DataSource = produtos;
                    tbcPrincipal.SelectedTab = tbpResultado;
                    lblNumeroPagina.Text = CurrentPage.ToString();
                }
            }
            catch (Exception ex)
            {
                GerenciadorExcecao.TratarExcecao(ex);
            }
            finally
            {
                this.Cursor = Cursors.Arrow;
            }

        }

        #region Paginacao

        private void btnVoltar_Click(object sender, EventArgs e)
        {
            if (CurrentPage <= 1) return;

            CurrentPageIndex -= 10;
            CurrentPage--;
            BuscarProdutos();
        }
        private void btnProxima_Click(object sender, EventArgs e)
        {
            CurrentPageIndex += 10;
            CurrentPage++;
            BuscarProdutos();
        }
        
        #endregion
    }
}