using Bbm.Bbmnet.Integracao.Business.Entities;
using Bbm.Bbmnet.Integracao.Business.Entities.Collections;
using Bbm.Bbmnet.Integracao.Util.Xml;
using ServiceTester.Integracao;
using ServiceTester.Util;
using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace ServiceTester.Produto
{
    public partial class ConsultarUnidadesMedida : Form
    {
        private const string cIdentificacao = "Cdigo: {0}, Nome: {1}";

        public ConsultarUnidadesMedida()
        {
            InitializeComponent();
        }

        private void btnExecutar_Click(object sender, EventArgs e)
        {            
            try
            {
                using (WCFIntegracaoClient proxy = ServiceFactory.GetIntegracaoInstance())
                {
                    BindingList<UnidadeProduto> resultado = new BindingList<UnidadeProduto>();
                    string result = string.Empty;                    
                    proxy.ConsultarUnidadesMedida();
                    result = proxy.ConsultarUnidadesMedida();
                    if (!string.IsNullOrEmpty(result))
                    {
                        UnidadeProdutoCollection unidades = Serializer.Deserialize<UnidadeProdutoCollection>(result);
                        unidades.ForEach(x => resultado.Add(x));                        
                    }
                    bsResultado.DataSource = resultado;
                    tbcPrincipal.SelectedTab = tbpResultado;                    
                }
            }
            catch (Exception ex)
            {
                GerenciadorExcecao.TratarExcecao(ex);
            }
        }
    }
}