﻿using ServiceTester.Integracao;
using System;
using System.Configuration;

namespace ServiceTester.Util
{
    public class ServiceFactory
    {
        public ServiceFactory()
        {
        }

        public static WCFIntegracaoClient GetIntegracaoInstance()
        {
            var client = new WCFIntegracaoClient();
            ConfigurarProxy(client.ClientCredentials, client.InnerChannel);
            return client;
        }

        private static void ConfigurarProxy(System.ServiceModel.Description.ClientCredentials credentials, System.ServiceModel.IClientChannel channel)
        {
            int TimeOut;
            try
            {
                int.TryParse(ConfigurationManager.AppSettings["TimeOut"], out TimeOut);
                if (TimeOut > 0)
                    channel.OperationTimeout = new TimeSpan(0, TimeOut, 0);
            }
            catch (Exception ex)
            {
                GerenciadorExcecao.TratarExcecao(ex);
            }
        }
    }
}
