using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;

namespace ServiceTester
{
    class EnumDataSource
    {
        public static void SetDataSource<T>(ListControl control)
        {
            control.DataSource = EnumDataSource.ObterLista<T>();
            control.ValueMember = "Codigo";
            control.DisplayMember = "Descricao";
        }

        public static void SetDataSource<T>(DataGridViewComboBoxColumn control)
        {
            control.DataSource = EnumDataSource.ObterLista<T>();
            control.ValueMember = "Codigo";
            control.DisplayMember = "Descricao";
        }

        private static List<ItemEnum> ObterLista<T>()
        {
            Type tipo = typeof(T);
            List<ItemEnum> lista = new List<ItemEnum>();
            foreach (int item in Enum.GetValues(tipo))
            {
                string itemName = Enum.GetName(tipo, item);
                lista.Add(new ItemEnum(item, itemName));
            }
            return lista;
        }
    }

    public static class EnumExtender
    {
        public static T Parse<T>(string valor)
        {
            return (T)Enum.Parse(typeof(T), valor, true);
        }
    }

    struct ItemEnum
    {
        int _codigo;
        string _descricao;

        public ItemEnum(int codigo, string descricao)
        {
            _codigo = codigo;
            _descricao = descricao;
        }

        public int Codigo
        {
            get { return _codigo; }
            set { _codigo = value; }
        }

        public string Descricao
        {
            get { return _descricao; }
            set { _descricao = value; }
        }
    }

    class Mimetypes
    {

        public static string GetMimeType(string fileName)
        {
            string _resultado = "application/octet-stream";
            try
            {
                RegistryKey classes = Registry.ClassesRoot;
                RegistryKey fileClass = classes.OpenSubKey(Path.GetExtension(fileName));
                _resultado = fileClass.GetValue("Content Type").ToString();
            }
            catch { }
            return _resultado;
        }
    }
}